;;;INICOM equ 1
;----------------------------------------------------------------------------
; PC-9821B2 IDE BIOS patch Version 5.20B (C) 2025/3/15 ܂
;----------------------------------------------------------------------------
CylnN           equ     es:[si+02h]
Dev_HS_MUL      equ     es:[si+08h]
DevSectN        equ     es:[si+0Ah]
DevHeadN        equ     es:[si+0Bh]
HS_MUL          equ     es:[si+0Ch]
SectN           equ     es:[si+0Eh]
HeadN           equ     es:[si+0Fh]

MEMseg          equ     5800h   ; < 8000h
IDE_equip       equ     10h     ; IDE BIOS bit
E10_equip       equ     20h     ; E10 BIOS bit(X-mateł͗v)  
SND_equip       equ     80h     ; SND BIOS bit(A-mate,FELLOW)
; Ƃ̂Ɏ܂ȂR[h̊i[ꏊ
LOCATION_IDP    equ     1900h   ; IDE BIOS̋󂫂͎gȂ悤ɂ
LOCATION_FUNC84 equ     1980h   ; 
LOCATION_CHSLBA equ     19C0h   ; 
LOCATION_LBACHS equ     1940h   ; 
LOCATION_CAPA   equ     1A00h   ; 
LOCATION_SET66  equ     1A60h
MSG_DISP_LINE   equ     13      ; \JnsłBKXĂB
; Global stack variables -----------------
SegTVRAM        equ     word ptr [bp-4] ; T-VRAM̃ZOgA000/E000
ROW             equ     word ptr [bp-6] ; \s
COLUMN          equ     word ptr [bp-8] ; \J
COLOR_ATTRIB    equ     byte ptr [bp-10] ; \F
HiresoFlag      equ     byte ptr [bp-11] ; 01h Hi-reso flag (bit 0)
StartLine       equ     byte ptr [bp-12] ;
MachineType     equ     byte ptr [bp-13] ; [1]=Ap2/As2/Af, [2]=B2
equip           equ     byte ptr [bp-14] ; 00h ; Flags of SCSI,IDE,SOUND BIOS existence
ModeID          equ     byte ptr [bp-15] ; ݂̃p[^[h
MemWindowAddr   equ     byte ptr [bp-16] ; 08-BANK window address in EXROM
MachineID       equ     byte ptr [bp-17] ; Machine ID
MemWindowNative equ     byte ptr [bp-18] ; 08-BANK window native address
mem_bank_IOaddr equ     word ptr [bp-20] ; 0461h/0091h(nC])
SegPhysIDEBIOS  equ     word ptr [bp-22] ; IDE BIOSZOgiIj
SegMMapIDEBIOS  equ     word ptr [bp-24] ; IDE BIOSZOgiRAMmappingj

code            segment public use16
                assume cs:code,ds:code,es:code,ss:code
                org 100h  ; for MS-DOS .COM file
start:
                jmp    program_start
                DB 0
                org 103h
title_msg       DB      0E1h,"IDE HDDeʏgCHSύXmANTI-CFؾānIDE BIOS QA-matep V5.20B",13,10,0
msg_not_for_A2  DB     041h,"PC-9821Ap2,As2,Af ȊŐ@ɂ͑Ή܂.",0

.186
program_start:  
;                mov     dx,1E8Eh
;                mov     al,81h
;                out     dx,al

                enter   30,0
                mov     COLOR_ATTRIB,0E1h
                cld
                call    ResoModeCheck   ; nC]^m[}`FbNT-VRAMZOg擾
                xor     ax,ax           ; AL=0
                mov     equip,al        ; bit̏l
                mov     MachineType,al  ; =0
                
                call    GetSeg_IDEBIOS  ; ^,RAMIDE BIOSZOg𓾂 2018-12-11V
                call    GetDisplayLine  ; ITF TEXTʕ\s̐ݒ
                call    DisplayTitle    ; ^Cg\
                call    ModelCheckAB2   ; @풲, B2,C2ȊO͒~(A2́H)
                jc      WrongMachine
                cmp     MachineType,0
                jz      WrongMachine

                call    Scan_GRPH_FK    ; 2024-3-25 ǉidlύXj 
                jc      CancelCTRL

                call    CheckMemSwitch  ; XCb`̃[hݒ擾
                jc      ExitProgram     ; CY=G[ŏI
                call    Exist_IDE_BIOS  ; IDE BIOS̑݃`FbN
                jc      ExitProgram     ; CY=G[Œ~

                call    NOPCI_Check     ; PCI BIOS邩HCY
                jc      WrongMachine    ; CYĂ΋@ႢŃG[
                call    PeriEnvCheck    ; 486@ƔfROM`FbN
                jc      WrongMachine    ; CY=G[Œ~

                call    DisplayEquip
                cmp     MachineType,1   ; Ap2,As2
                jNe     To_abort

                call    ROMtoMEM        ; IDE BIOS ROMMEMɓ] 8KB 2 time
                call    A2_patch        ; A2@̃pb`
                jc      WrongBIOS

                call    SetChkSum
PatchSucces:
                call    MEMtoIDEBIOS    ; ̍ƌʂRAM BIOSɃRs[
                call    ClearMEMseg     ; ƃNAđދ
ExitProgram:
                call    ShiftKeyCheck   ; VtgL[ŕ\ꎞ~

ifdef   INICOM  ; eXgp
                mov     ax,0380h
                int     1Bh
endif
                leave
                RET    ; near ^[ŏI
;-------------------------------------------
WrongMachine:   mov     dx,offset wrong_msg 
                call    _puts   ; ű@ɂ͑ΉĂ܂v\
                jmp     ExitProgram     ; G[ŏI
CancelCTRL:     mov     dx,offset msg_CRLF
                call    _puts
                jmp     AvoidPatch
WrongBIOS:      call    Poop ; ````
                dec     ROW
                mov     dx,offset wrong_bios    ; uΉBIOSł͂Ȃv
                call    _puts
AvoidPatch:     mov     dx,offset msg_AvoidPatch; u~܂v 
                call    _puts
                jmp     ExitProgram
To_abort:       mov     dx,offset msg_not_for_A2
                call    _puts
                call    Poop ; ````
                jmp     AvoidPatch

;--------------------------------------------------------
;       machines
;--------------------------------------------------------

include patch_a2.s

;------------------------------------------------------------
;       ModelCheckAB2
;------------------------------------------------------------
ModelCheckAB2   PROC   near
                mov     al,MachineID
                cmp     al,07h  ; Bp,Bs,Be,PC-9801 BX2,BA2
                je      Machine_B2
                cmp     al,08h  ; Ce2,Cs2
                je      Machine_C2
                cmp     al,05h ; Af
                je      Machine_A2
                cmp     al,81h ; Af(H)
                je      Machine_A2
                cmp     al,06h ; Ap2,As2
                je      Machine_A2
                cmp     al,82h ; Ap2,As2(H)
                je      Machine_A2

                mov     MachineType,0
                stc
                ret
Machine_C2:     mov     MachineType,4   ; 4=Cs2,Ce2
                clc
                ret
Machine_B2:     mov     MachineType,2   ; 2=B2
                clc
                ret
Machine_A2:     mov     MachineType,1   ; Af,Ap2,As2
                clc
                ret
ModelCheckAB2   ENDP

;------------------------------
include ..\bx2\memcopy.inc
include ..\bx2\ideptcom.inc
include ..\bx2\numeric.inc     ; l\[`
include e:\asmlib\putstrCS.inc      ; \[`i\[X͕t܂j
;-----------------------------------------
;--------------------------------------
.186

;--------------------------------------
;  W    [2082h]    CylnN(BIOS,logical)
;  B    [208Ah]    SectN(device,physical)
;  B    [208Bh]    HeadN(device,physical)
;  W    [208Ch]    Head:SectN(device,physical)

;  B    [208Eh]    SectN(BIOS,logical)
;  B    [208Fh]    HeadN(BIOS,logical)

;----------------------------------
PatPtn2_Func84  label word      ; offset 033Fh
                push    ax
                mov     si,2080h
                test    byte ptr [bp+00],01h
                jz      @f
                mov     si,2090h
        @@:
                mov     al,byte ptr SectN  ; S
                mov     [bp+06h],al
                mov     al,byte ptr HeadN  ; H
                mov     [bp+07h],al
                mov     dx,word ptr CylnN  ; C
                mov     [bp+04h],dx
                pop     ax
                ret
PatPtn2_Func84_end  label word

;--------------------------------

;----------------------------------
include patch5A2.s

code    ends
        end     start
